/*
 * File:   main.c
 * Author: family
 *
 * Created on 2011/07/23, 15:20
 */
//#include "pic.h"
#include <htc.h>

#include "seg7.h"
#include "HW_Config.h"
#include "sdelay.h"
#include "sound.h"
#include "games.h"

__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_OFF & BOREN_OFF);	// Program config. word 1
__CONFIG(PLLEN_OFF & BORV_19 );	// Program config. word 2

__EEPROM_DATA(0, 0, 0, 0, 0xFF, 0xFF, 0xFF, 0xFF);  // high score


void wait_SW1(unsigned char dsp);

int main(void) {

    unsigned char i_game;
    unsigned char hsc;
    unsigned char i;


    OSCCON = 0b01101000;    // bit7: SPLLEN = OFF
    // bit6-3: 4MHz
                            // bit 1-0: Clock determined by Config
    OPTION_REG = 0b01010001;    // bit7: 0 =  Weak pull-ups are enabled
                                // bit5: 0 = Internal instruction cycle clock
                                // bit3: 0 = Prescaler is assigned to the Timer0 module
                                // bit2-0: Prescaler Rate 001 = 1:4

    ANSELA = 0;
    ANSELC = 0;

    TRISC = 0;
    TRISA = 0b11101011;
    Set7Seg(Soff);

    // Clear High Score
    if(SW1 == 0 && nRI == 1){
        unsigned char i;
        Set7Seg(SC);
        for(i=0; i<60; i++){
            sdelay_50ms();
            if(SW1) break;
        }
        if(i==60){
            sound_on(7, 100);
            for(i=0; i<4; i++){
                eeprom_write(i, 0);
            }
        }
        while(!SW1);
        Set7Seg(Soff);
    }
    
    while(1)    {
//        while(SW1){
//            Set7Seg(Seg7[SLCT+1]);
//        }
        sdelay_100ms();
        while(!SW1);
        sdelay_100ms();
        wait_SW1(1);
        i_game = SLCT;
        for(i=0; i<60; i++){
            sdelay_50ms();
            if(SW1) break;
        }
        if(i==60){
            Set7Seg(SH);
            while(!SW1);
            sdelay_1s();
            pt = eeprom_read(i_game);
            if(i_game == 3){
                dsp_lvl();
            }
            else{
                dsp_pt2d();
            }
            Set7Seg(Soff);
            sdelay_1s();
            continue;
        }
        rnd = TMR0;
        pt = 0;
        sdelay_50ms();

        switch(i_game){
            case 0:
                slot();
                break;
            case 1:
                nezumi();
                break;
            case 2:
                hitodds();
                break;
            case 3:
                hit2nd();
                break;
        }
        hsc = eeprom_read(i_game);
        if(pt > hsc){
            Set7Seg(SH);
            eeprom_write(i_game, pt);
            sound_pkmn();
            wait_SW1(0);
        }
//        sdelay_100ms();
//        while(!SW1);
        Set7Seg(Soff);
        sdelay_1s();
    }
    return 0;
}

void interrupt isr(void){
    SPK = !SPK;
    TMR0 = t0;
    T0IF = 0;
}

void wait_SW1(unsigned char dsp){
    unsigned char t;

    IOCAN_SW1 = 1;
    if(!SW1){
        return;
    }
    IOCAF_SW1 = 0;
    for(t=0; t<0xFF; t++){
        if(dsp)
            Set7Seg(Seg7[SLCT+1]);
        sdelay_100ms();
        if(IOCAF_SW1){
            sdelay_50ms();
            return;
        }
    }
    Set7Seg(Soff);
    SOUND_Soff();
    SLP_SLCT();
    IOCIE = 1;
    SLEEP();
    NOP();
    asm("RESET");

}



